// I2C RTC EPSON RTC-8564 functions  By H.machida@MNCT-S 2003/10/9
// rtc_lib.c

// global variables

int year,month,week,day,hour,min,sec;                // 
char h_year,h_month,h_week,h_day,h_hour,h_min,h_sec; // 2
char l_year,l_month,l_week,l_day,l_hour,l_min,l_sec; // 1

// y<1>tݒz
void rtc_date_set()
{
    i2c_start();
    i2c_write(0xa2); // ݃[h
    i2c_write(0x02); // b̃AhX
    i2c_write(sec);  // b̒l 0-59
    i2c_write(min);  // ̒l 0-59
    i2c_write(hour); // ̒l 0-23
    i2c_write(day);  // ̒l 1-31
    i2c_write(week); // j̒l ΐ؋y 0123456 5bitDon't Car
    i2c_write(month);// ̒l (C:MSB)1-12   C1̂Ƃ21I
    i2c_write(year); // N̒l 00-99
    i2c_stop();
}

// y<2>tǂݏoz
void rtc_date_read(){
	i2c_start();
    i2c_write(0xa2); // ݃[h
    i2c_write(0x02); // b̃AhX
    i2c_start();
    i2c_write(0xa3); // ǂݍ݃[h
    sec=  i2c_read(1); // b̒l
    min=  i2c_read(1); // ̒l
    hour= i2c_read(1); // ̒l
    day=  i2c_read(1); // ̒l
    week= i2c_read(1); // j̒l
    month=i2c_read(1); // ̒l
    year= i2c_read(0); // N̒l
    i2c_stop();
	bit_clear(month,7);
	bit_clear(month,6);
	bit_clear(month,5);
	bit_clear(day,7);
	bit_clear(day,6);
	bit_clear(hour,7);
	bit_clear(hour,6);
	bit_clear(min,7);
	bit_clear(sec,7);

    h_sec=  ((  sec>>4)&0x07)|0x30; l_sec=  (  sec&0x0f)|0x30; 
    h_min=  ((  min>>4)&0x07)|0x30; l_min=  (  min&0x0f)|0x30; 
    h_hour= (( hour>>4)&0x03)|0x30; l_hour= ( hour&0x0f)|0x30; 
    h_day=  ((  day>>4)&0x03)|0x30; l_day=  (  day&0x0f)|0x30; 
    h_week=                      0; l_week= ( week&0x0f)|0x30; 
    h_month=((month>>4)&0x01)|0x30; l_month=(month&0x0f)|0x30; 
    h_year= (( year>>4)&0x0f)|0x30; l_year= ( year&0x0f)|0x30; 
}

// y<3>A[̐ݒz10ɃA[o͂B
void rtc_alarm_set(int aweek,int aday,int ahour,int amin)
{
    i2c_start();
    i2c_write(0xa2);  // ݃[h
    i2c_write(0x09);  // A[̃AhX
    i2c_write(amin);  // A[̒l 0-59 MSBAE
    i2c_write(ahour); // A[̒l 0-23
    i2c_write(aday);  // A[̒l 1-31
    i2c_write(aweek); // A[j̒l ΐ؋y 0123456 
    i2c_stop();       //                5bit Don't Care
}

// y<4>^C}Ag̐ݒzg1Hz,^C}10bݒ
void rtc_timer_set(int tfreq,int tcont,int timer)
{
    i2c_start();
    i2c_write(0xa2);  // ݃[h
    i2c_write(0x0D);  // NbNo͎g̃AhX
    i2c_write(tfreq); // NbNo͎g̒l
    i2c_write(tcont); // ^C}l
    i2c_write(timer); // ^C}l
    i2c_stop();
}

